package org.framework.lazy.cloud.network.heartbeat.server.standalone.application;


import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.command.lazy.netty.server.permeate.client.mapping.*;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.dto.LazyInternalNetworkPenetrationMappingDTO;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.domain.model.lazy.netty.server.permeate.client.mapping.LazyNettyServerPermeateClientMapping;
import org.wu.framework.lazy.orm.database.lambda.domain.LazyPage;
import org.wu.framework.web.response.Result;
import org.wu.framework.lazy.orm.core.persistence.reverse.lazy.ddd.DefaultDDDLazyApplication;

import java.util.List;

/**
 * describe 内网穿透映射
 *
 * @author Jia wei Wu
 * @date 2023/12/29 05:21 下午
 * @see DefaultDDDLazyApplication
 **/

public interface LazyInternalNetworkServerPermeateClientMappingApplication {


    /**
     * describe 新增内网穿透映射
     *
     * @param lazyInternalNetworkServerPermeateClientMappingStoryCommand 新增内网穿透映射
     * @return {@link Result<   LazyNettyServerPermeateClientMapping   >} 内网穿透映射新增后领域对象
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/

    Result<LazyNettyServerPermeateClientMapping> story(LazyInternalNetworkServerPermeateClientMappingStoryCommand lazyInternalNetworkServerPermeateClientMappingStoryCommand) ;

    /**
     * describe 批量新增内网穿透映射
     *
     * @param lazyInternalNetworkServerPermeateClientMappingStoryCommandList 批量新增内网穿透映射
     * @return {@link Result<List<   LazyNettyServerPermeateClientMapping   >>} 内网穿透映射新增后领域对象集合
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/

    Result<List<LazyNettyServerPermeateClientMapping>> batchStory(List<LazyInternalNetworkServerPermeateClientMappingStoryCommand> lazyInternalNetworkServerPermeateClientMappingStoryCommandList);

    /**
     * describe 更新内网穿透映射
     *
     * @param lazyInternalNetworkServerPermeateClientMappingUpdateCommand 更新内网穿透映射
     * @return {@link Result<   LazyNettyServerPermeateClientMapping   >} 内网穿透映射领域对象
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/

    Result<LazyNettyServerPermeateClientMapping> updateOne(LazyInternalNetworkServerPermeateClientMappingUpdateCommand lazyInternalNetworkServerPermeateClientMappingUpdateCommand) ;

    /**
     * describe 查询单个内网穿透映射
     *
     * @param lazyInternalNetworkServerPermeateClientMappingQueryOneCommand 查询单个内网穿透映射
     * @return {@link Result<   LazyInternalNetworkPenetrationMappingDTO   >} 内网穿透映射DTO对象
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/

    Result<LazyInternalNetworkPenetrationMappingDTO> findOne(LazyInternalNetworkServerPermeateClientMappingQueryOneCommand lazyInternalNetworkServerPermeateClientMappingQueryOneCommand);

    /**
     * describe 查询多个内网穿透映射
     *
     * @param lazyInternalNetworkServerPermeateClientMappingQueryListCommand 查询多个内网穿透映射
     * @return {@link Result <List<LazyInternalNetworkPenetrationMappingDTO>>} 内网穿透映射DTO对象
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/

    Result<List<LazyInternalNetworkPenetrationMappingDTO>> findList(LazyInternalNetworkServerPermeateClientMappingQueryListCommand lazyInternalNetworkServerPermeateClientMappingQueryListCommand);

    /**
     * describe 分页查询多个内网穿透映射
     *
     * @param lazyInternalNetworkServerPermeateClientMappingQueryListCommand 分页查询多个内网穿透映射
     * @return {@link Result <LazyPage<LazyInternalNetworkPenetrationMappingDTO>>} 分页内网穿透映射DTO对象
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/

    Result<LazyPage<LazyInternalNetworkPenetrationMappingDTO>> findPage(int size, int current, LazyInternalNetworkServerPermeateClientMappingQueryListCommand lazyInternalNetworkServerPermeateClientMappingQueryListCommand);

    /**
     * describe 删除内网穿透映射
     *
     * @param lazyInternalNetworkServerPermeateClientMappingRemoveCommand 删除内网穿透映射
     * @return {@link Result<   LazyNettyServerPermeateClientMapping   >} 内网穿透映射
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/

    Result<LazyNettyServerPermeateClientMapping> remove(LazyInternalNetworkServerPermeateClientMappingRemoveCommand lazyInternalNetworkServerPermeateClientMappingRemoveCommand);

    /**
     * 创建客户端的访问者
     *
     * @param clientId 客户端ID
     */
    Result<Void> createVisitor(String clientId);
}