package org.framework.lazy.cloud.network.heartbeat.server.standalone.application.assembler;

import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.command.lazy.netty.server.permeate.client.mapping.*;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.domain.model.lazy.netty.server.permeate.client.mapping.LazyNettyServerPermeateClientMapping;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.dto.LazyInternalNetworkPenetrationMappingDTO;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;
import org.wu.framework.lazy.orm.core.persistence.reverse.lazy.ddd.DefaultDDDLazyAssembler;

/**
 * describe 内网穿透映射
 *
 * @author Jia wei Wu
 * @date 2023/12/29 05:21 下午
 * @see DefaultDDDLazyAssembler
 **/
@Mapper
public interface InternalNetworkPenetrationMappingDTOAssembler {


    /**
     * describe MapStruct 创建的代理对象
     *
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/
    InternalNetworkPenetrationMappingDTOAssembler INSTANCE = Mappers.getMapper(InternalNetworkPenetrationMappingDTOAssembler.class);

    /**
     * describe 应用层存储入参转换成 领域对象
     *
     * @param lazyInternalNetworkServerPermeateClientMappingStoryCommand 保存内网穿透映射对象
     * @return {@link LazyNettyServerPermeateClientMapping} 内网穿透映射领域对象
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/
    LazyNettyServerPermeateClientMapping toInternalNetworkPenetrationMapping(LazyInternalNetworkServerPermeateClientMappingStoryCommand lazyInternalNetworkServerPermeateClientMappingStoryCommand);

    /**
     * describe 应用层更新入参转换成 领域对象
     *
     * @param lazyInternalNetworkServerPermeateClientMappingUpdateCommand 更新内网穿透映射对象
     * @return {@link LazyNettyServerPermeateClientMapping} 内网穿透映射领域对象
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/
    LazyNettyServerPermeateClientMapping toInternalNetworkPenetrationMapping(LazyInternalNetworkServerPermeateClientMappingUpdateCommand lazyInternalNetworkServerPermeateClientMappingUpdateCommand);

    /**
     * describe 应用层查询入参转换成 领域对象
     *
     * @param lazyInternalNetworkServerPermeateClientMappingQueryOneCommand 查询单个内网穿透映射对象参数
     * @return {@link LazyNettyServerPermeateClientMapping} 内网穿透映射领域对象
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/
    LazyNettyServerPermeateClientMapping toInternalNetworkPenetrationMapping(LazyInternalNetworkServerPermeateClientMappingQueryOneCommand lazyInternalNetworkServerPermeateClientMappingQueryOneCommand);

    /**
     * describe 应用层查询入参转换成 领域对象
     *
     * @param lazyInternalNetworkServerPermeateClientMappingQueryListCommand 查询集合内网穿透映射对象参数
     * @return {@link LazyNettyServerPermeateClientMapping} 内网穿透映射领域对象
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/
    LazyNettyServerPermeateClientMapping toInternalNetworkPenetrationMapping(LazyInternalNetworkServerPermeateClientMappingQueryListCommand lazyInternalNetworkServerPermeateClientMappingQueryListCommand);

    /**
     * describe 应用层删除入参转换成 领域对象
     *
     * @param lazyInternalNetworkServerPermeateClientMappingRemoveCommand 删除内网穿透映射对象参数
     * @return {@link LazyNettyServerPermeateClientMapping} 内网穿透映射领域对象
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/
    LazyNettyServerPermeateClientMapping toInternalNetworkPenetrationMapping(LazyInternalNetworkServerPermeateClientMappingRemoveCommand lazyInternalNetworkServerPermeateClientMappingRemoveCommand);

    /**
     * describe 持久层领域对象转换成DTO对象
     *
     * @param lazyNettyServerPermeateClientMapping 内网穿透映射领域对象
     * @return {@link LazyInternalNetworkPenetrationMappingDTO} 内网穿透映射DTO对象
     * @author Jia wei Wu
     * @date 2023/12/29 05:21 下午
     **/
    LazyInternalNetworkPenetrationMappingDTO fromInternalNetworkPenetrationMapping(LazyNettyServerPermeateClientMapping lazyNettyServerPermeateClientMapping);
}