package org.framework.lazy.cloud.network.heartbeat.server.standalone.controller;

import io.swagger.v3.oas.annotations.tags.Tag;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.domain.model.lazy.netty.client.permeate.server.mapping.LazyNettyClientPermeateServerMapping;
import org.wu.framework.web.spring.EasyController;
import org.springframework.web.bind.annotation.*;
import org.wu.framework.web.response.Result;
import jakarta.annotation.Resource;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.command.lazy.netty.client.permeate.server.mapping.LazyInternalNetworkClientPermeateServerMappingRemoveCommand;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.command.lazy.netty.client.permeate.server.mapping.LazyInternalNetworkClientPermeateServerMappingStoryCommand;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.command.lazy.netty.client.permeate.server.mapping.LazyInternalNetworkClientPermeateServerMappingUpdateCommand;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.command.lazy.netty.client.permeate.server.mapping.LazyInternalNetworkClientPermeateServerMappingQueryListCommand;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.command.lazy.netty.client.permeate.server.mapping.LazyInternalNetworkClientPermeateServerMappingQueryOneCommand;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.LazyInternalNetworkClientPermeateServerMappingApplication;
import org.framework.lazy.cloud.network.heartbeat.server.standalone.application.dto.LazyInternalNetworkClientPermeateServerMappingDTO;
import java.util.List;
import org.wu.framework.lazy.orm.database.lambda.domain.LazyPage;
/**
 * describe 客户端渗透服务端映射 
 *
 * @author Jia wei Wu
 * @date 2024/09/17 09:26 晚上
 * @see org.wu.framework.lazy.orm.core.persistence.reverse.lazy.ddd.DefaultDDDLazyController 
 **/
@Tag(name = "客户端渗透服务端映射提供者")
@EasyController("/lazy/internal/network/client/permeate/server/mapping")
public class LazyInternalNetworkClientPermeateServerMappingProvider  {

    @Resource
    private LazyInternalNetworkClientPermeateServerMappingApplication lazyInternalNetworkClientPermeateServerMappingApplication;

    /**
     * describe 新增客户端渗透服务端映射
     *
     * @param lazyInternalNetworkClientPermeateServerMappingStoryCommand 新增客户端渗透服务端映射     
     * @return {@link Result< LazyNettyClientPermeateServerMapping >} 客户端渗透服务端映射新增后领域对象
     
     * @author Jia wei Wu
     * @date 2024/09/17 09:26 晚上
     **/

    @Operation(summary = "新增客户端渗透服务端映射")
    @PostMapping("/story")
    public Result<LazyNettyClientPermeateServerMapping> story(@RequestBody LazyInternalNetworkClientPermeateServerMappingStoryCommand lazyInternalNetworkClientPermeateServerMappingStoryCommand){
        return lazyInternalNetworkClientPermeateServerMappingApplication.story(lazyInternalNetworkClientPermeateServerMappingStoryCommand);
    }
    /**
     * describe 批量新增客户端渗透服务端映射
     *
     * @param lazyInternalNetworkClientPermeateServerMappingStoryCommandList 批量新增客户端渗透服务端映射     
     * @return {@link Result<List< LazyNettyClientPermeateServerMapping >>} 客户端渗透服务端映射新增后领域对象集合
     
     * @author Jia wei Wu
     * @date 2024/09/17 09:26 晚上
     **/

    @Operation(summary = "批量新增客户端渗透服务端映射")
    @PostMapping("/batchStory")
    public Result<List<LazyNettyClientPermeateServerMapping>> batchStory(@RequestBody List<LazyInternalNetworkClientPermeateServerMappingStoryCommand> lazyInternalNetworkClientPermeateServerMappingStoryCommandList){
        return lazyInternalNetworkClientPermeateServerMappingApplication.batchStory(lazyInternalNetworkClientPermeateServerMappingStoryCommandList);
    }
    /**
     * describe 更新客户端渗透服务端映射
     *
     * @param lazyInternalNetworkClientPermeateServerMappingUpdateCommand 更新客户端渗透服务端映射     
     * @return {@link Result< LazyNettyClientPermeateServerMapping >} 客户端渗透服务端映射领域对象
     
     * @author Jia wei Wu
     * @date 2024/09/17 09:26 晚上
     **/

    @Operation(summary = "更新客户端渗透服务端映射")
    @PutMapping("/updateOne")
    public Result<LazyNettyClientPermeateServerMapping> updateOne(@RequestBody LazyInternalNetworkClientPermeateServerMappingUpdateCommand lazyInternalNetworkClientPermeateServerMappingUpdateCommand){
        return lazyInternalNetworkClientPermeateServerMappingApplication.updateOne(lazyInternalNetworkClientPermeateServerMappingUpdateCommand);
    }
    /**
     * describe 查询单个客户端渗透服务端映射
     *
     * @param lazyInternalNetworkClientPermeateServerMappingQueryOneCommand 查询单个客户端渗透服务端映射     
     * @return {@link Result<LazyInternalNetworkClientPermeateServerMappingDTO>} 客户端渗透服务端映射DTO对象     
     
     * @author Jia wei Wu
     * @date 2024/09/17 09:26 晚上
     **/

    @Operation(summary = "查询单个客户端渗透服务端映射")
    @GetMapping("/findOne")
    public Result<LazyInternalNetworkClientPermeateServerMappingDTO> findOne(@ModelAttribute LazyInternalNetworkClientPermeateServerMappingQueryOneCommand lazyInternalNetworkClientPermeateServerMappingQueryOneCommand){
        return lazyInternalNetworkClientPermeateServerMappingApplication.findOne(lazyInternalNetworkClientPermeateServerMappingQueryOneCommand);
    }
    /**
     * describe 查询多个客户端渗透服务端映射
     *
     * @param lazyInternalNetworkClientPermeateServerMappingQueryListCommand 查询多个客户端渗透服务端映射     
     * @return {@link Result<List<LazyInternalNetworkClientPermeateServerMappingDTO>>} 客户端渗透服务端映射DTO对象     
     
     * @author Jia wei Wu
     * @date 2024/09/17 09:26 晚上
     **/

    @Operation(summary = "查询多个客户端渗透服务端映射")
    @GetMapping("/findList")
    public Result<List<LazyInternalNetworkClientPermeateServerMappingDTO>> findList(@ModelAttribute LazyInternalNetworkClientPermeateServerMappingQueryListCommand lazyInternalNetworkClientPermeateServerMappingQueryListCommand){
        return lazyInternalNetworkClientPermeateServerMappingApplication.findList(lazyInternalNetworkClientPermeateServerMappingQueryListCommand);
    }
    /**
     * describe 分页查询多个客户端渗透服务端映射
     *
     * @param lazyInternalNetworkClientPermeateServerMappingQueryListCommand 分页查询多个客户端渗透服务端映射     
     * @return {@link Result<LazyPage<LazyInternalNetworkClientPermeateServerMappingDTO>>} 分页客户端渗透服务端映射DTO对象     
     
     * @author Jia wei Wu
     * @date 2024/09/17 09:26 晚上
     **/

    @Operation(summary = "分页查询多个客户端渗透服务端映射")
    @GetMapping("/findPage")
    public Result<LazyPage<LazyInternalNetworkClientPermeateServerMappingDTO>> findPage(@Parameter(description ="分页大小") @RequestParam(defaultValue = "10", value = "size") int size,
                           @Parameter(description ="当前页数") @RequestParam(defaultValue = "1", value = "current") int current,@ModelAttribute LazyInternalNetworkClientPermeateServerMappingQueryListCommand lazyInternalNetworkClientPermeateServerMappingQueryListCommand){
        return lazyInternalNetworkClientPermeateServerMappingApplication.findPage(size,current,lazyInternalNetworkClientPermeateServerMappingQueryListCommand);
    }
    /**
     * describe 删除客户端渗透服务端映射
     *
     * @param lazyInternalNetworkClientPermeateServerMappingRemoveCommand 删除客户端渗透服务端映射     
     * @return {@link Result< LazyNettyClientPermeateServerMapping >} 客户端渗透服务端映射
     
     * @author Jia wei Wu
     * @date 2024/09/17 09:26 晚上
     **/

    @Operation(summary = "删除客户端渗透服务端映射")
    @DeleteMapping("/remove")
    public Result<LazyNettyClientPermeateServerMapping> remove(@ModelAttribute LazyInternalNetworkClientPermeateServerMappingRemoveCommand lazyInternalNetworkClientPermeateServerMappingRemoveCommand){
        return lazyInternalNetworkClientPermeateServerMappingApplication.remove(lazyInternalNetworkClientPermeateServerMappingRemoveCommand);
    }
}